package fr.jsoula.jboss.drools.bugs.comparable;

import java.util.Arrays;
import java.util.Collection;
import org.drools.KnowledgeBase;
import org.drools.KnowledgeBaseFactory;
import org.drools.builder.KnowledgeBuilder;
import org.drools.builder.KnowledgeBuilderFactory;
import org.drools.builder.ResourceType;
import org.drools.definition.KnowledgePackage;
import org.drools.io.ResourceFactory;
import org.joda.time.LocalDate;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class ComparableBug {
    private static final Logger LOGGER = LoggerFactory.getLogger(ComparableBug.class);

    public static void main(String[] args) {
        final KnowledgeBuilder kbuilder = KnowledgeBuilderFactory.newKnowledgeBuilder();

        // this will parse and compile in one step
        kbuilder.add(ResourceFactory.newClassPathResource("LocalDateForDroolsTest.drl", ComparableBug.class), ResourceType.DRL);

        // Check the builder for errors
        if (kbuilder.hasErrors()) {
            System.out.println(kbuilder.getErrors().toString());
            throw new RuntimeException("Unable to compile \"LocalDateForDroolsTest.drl\".");
        }

        // get the compiled packages (which are serializable)
        final Collection<KnowledgePackage> pkgs = kbuilder.getKnowledgePackages();

        // add the packages to a knowledgebase (deploy the knowledge packages).
        final KnowledgeBase kbase = KnowledgeBaseFactory.newKnowledgeBase();
        kbase.addKnowledgePackages(pkgs);
        for (int i = 0; i < 100; i++) {
            System.out.println(i);
            kbase.newStatelessKnowledgeSession().execute(Arrays.asList(new LocalDateForDroolsTestBean(new LocalDate(), new LocalDate())));
        }
    }
}
